/*
 * Intel ACPI Component Architecture
 * AML/ASL+ Disassembler version 20200925 (64-bit version)
 * Copyright (c) 2000 - 2020 Intel Corporation
 * 
 * Disassembling to symbolic ASL+ operators
 *
 * Disassembly of iASLR3pqJ2.aml, Fri Jan  1 20:32:25 2021
 *
 * Original Table Header:
 *     Signature        "SSDT"
 *     Length           0x00000AA8 (2728)
 *     Revision         0x02
 *     Checksum         0x44
 *     OEM ID           "hack"
 *     OEM Table ID     "batt"
 *     OEM Revision     0x00000000 (0)
 *     Compiler ID      "INTL"
 *     Compiler Version 0x20200925 (538970405)
 */
DefinitionBlock ("", "SSDT", 2, "hack", "batt", 0x00000000)
{
    External (BSLF, IntObj)
    External (_SB.PCI0.BAT0.PBIF)
    External (_SB.PCI0.BAT0.BIXT)
    External (_SB.PCI0.LPCB, DeviceObj)
    External (_SB.PCI0.LPCB.EC0, DeviceObj)
    External (_SB.PCI0.LPCB.EC0.DAT0)
    External (_SB.PCI0.LPCB.EC0.ECAV, MethodObj)
    External (_SB.PCI0.LPCB.EC0.MUEC, MutexObj)
    External (_SB.PCI0.LPCB.EC0.SWTC, MethodObj)

    Method (B1B2, 2, NotSerialized)
    {
        Return ((Arg0 | (Arg1 << 0x08)))
    }

    Scope (_SB.PCI0.LPCB.EC0)
    {
        Name (WRQK, 0x02)
        Name (RDQK, 0x03)
        Name (SDBT, 0x04)
        Name (RCBT, 0x05)
        Name (WRBT, 0x06)
        Name (RDBT, 0x07)
        Name (WRWD, 0x08)
        Name (RDWD, 0x09)
        Name (WRBL, 0x0A)
        Name (RDBL, 0x0B)
        Name (PCLL, 0x0C)
        Name (GOOD, Zero)
        Name (UKER, 0x07)
        Name (DAER, 0x10)
        Name (CMDN, 0x12)
        Name (UKE2, 0x13)
        Name (DADN, 0x17)
        Name (SBTO, 0x18)
        Name (USPT, 0x19)
        Name (SBBY, 0x1A)
        
        OperationRegion (ECOR, EmbeddedControl, Zero, 0xFF)
        Field (ECOR, ByteAcc, Lock, Preserve)
        {
            Offset (0x04), 
            CMD1,   8, 
            CDT1,   8, 
            CDT2,   8, 
            CDT3,   8, 
            Offset (0x80), 
            Offset (0x81), 
            Offset (0x82), 
            Offset (0x83), 
            EB0R,   8, 
            EB1R,   8, 
            EPWF,   8, 
            Offset (0x87), 
            Offset (0x88), 
            Offset (0x89), 
            Offset (0x8A), 
            HKEN,   1, 
            Offset (0x93), 
            TH00,   8, // was TAH0, 16
            TH01,   8, 
            TH10,   8, // was TAH1, 16
            TH11,   8, 
            TSTP,   8, 
            Offset (0x9C), 
            CDT4,   8, 
            CDT5,   8, 
            Offset (0xA0), 
            Offset (0xA1), 
            Offset (0xA2), 
            Offset (0xA3), 
            EACT,   8, 
            TH1R,   8, 
            TH1L,   8, 
            TH0R,   8, 
            TH0L,   8, 
            Offset (0xB0), 
            B0PN,   16, 
            Offset (0xB4), 
            Offset (0xB6), 
            Offset (0xB8), 
            Offset (0xBA), 
            Offset (0xBC), 
            Offset (0xBE), 
            B0TM,   16, 
            B0C1,   16, 
            B0C2,   16, 
            XC30,   8, // was B0C3, 16
            XC31,   8, 
            B0C4,   16, 
            Offset (0xD0), 
            B1PN,   16, 
            Offset (0xD4), 
            Offset (0xD6), 
            Offset (0xD8), 
            Offset (0xDA), 
            Offset (0xDC), 
            Offset (0xDE), 
            B1TM,   16, 
            B1C1,   16, 
            B1C2,   16, 
            YC30,   8, // was B1C3, 16
            YC31,   8, 
            B1C4,   16, 
            Offset (0xF0), 
            Offset (0xF2), 
            Offset (0xF4), 
            B0S0,   8, // was B0SN, 16
            B0S1,   8, 
            Offset (0xF8), 
            Offset (0xFA), 
            Offset (0xFC), 
            B1S0,   8, // was B1SN, 16
            B1S1,   8
        }

        Name (SMBF, Zero)
        OperationRegion (SMBX, EmbeddedControl, 0x18, 0x28)
        Field (SMBX, ByteAcc, NoLock, Preserve)
        {
            PRTC,   8, 
            SSTS,   5, 
                ,   1, 
            ALFG,   1, 
            CDFG,   1, 
            ADDR,   8, 
            CMDB,   8, 
            BA00,   8, 
            BA01,   8, 
            BA02,   8, 
            BA03,   8, 
            BA04,   8, 
            BA05,   8, 
            BA06,   8, 
            BA07,   8, 
            BA08,   8, 
            BA09,   8, 
            BA0A,   8, 
            BA0B,   8, 
            BA0C,   8, 
            BA0D,   8, 
            BA0E,   8, 
            BA0F,   8, 
            BA10,   8, 
            BA11,   8, 
            BA12,   8, 
            BA13,   8, 
            BA14,   8, 
            BA15,   8, 
            BA16,   8, 
            BA17,   8, 
            BA18,   8, 
            BA19,   8, 
            BA1A,   8, 
            BA1B,   8, 
            BA1C,   8, 
            BA1D,   8, 
            BA1E,   8, 
            BA1F,   8, 
            BCNT,   8, 
                ,   1, 
            ALAD,   7, 
            ALD0,   8, 
            ALD1,   8
        }

        OperationRegion (SMB2, EmbeddedControl, 0x40, 0x28)
        Field (SMB2, ByteAcc, NoLock, Preserve)
        {
            PRT2,   8, 
            SST2,   5, 
                ,   1, 
            ALF2,   1, 
            CDF2,   1, 
            ADD2,   8, 
            CMD2,   8, 
            BB00,   8, 
            BB01,   8, 
            BB02,   8, 
            BB03,   8, 
            BB04,   8, 
            BB05,   8, 
            BB06,   8, 
            BB07,   8, 
            BB08,   8, 
            BB09,   8, 
            BB0A,   8, 
            BB0B,   8, 
            BB0C,   8, 
            BB0D,   8, 
            BB0E,   8, 
            BB0F,   8, 
            BB10,   8, 
            BB11,   8, 
            BB12,   8, 
            BB13,   8, 
            BB14,   8, 
            BB15,   8, 
            BB16,   8, 
            BB17,   8, 
            BB18,   8, 
            BB19,   8, 
            BB1A,   8, 
            BB1B,   8, 
            BB1C,   8, 
            BB1D,   8, 
            BB1E,   8, 
            BB1F,   8, 
            BCN2,   8, 
                ,   1, 
            ALA2,   7, 
            ALR0,   8, 
            ALR1,   8
        }

        Field (SMBX, ByteAcc, NoLock, Preserve)
        {
            Offset (0x04), 
            T2B0,   8, // was DT2B, 16
            T2B1,   8
        }
        
        Method (BIFA, 0, NotSerialized)
        {
            If (ECAV ())
            {
                If (BSLF)
                {
                    Local0 = B1B2 (B1S0, B1S1) // B1SN /* \_SB_.PCI0.LPCB.EC0_.B1SN */
                }
                Else
                {
                    Local0 = B1B2 (B0S0,B0S1) // B0SN /* \_SB_.PCI0.LPCB.EC0_.B0SN */
                }
            }
            Else
            {
                Local0 = Ones
            }

            Return (Local0)
        }
        
        Method (TACH, 1, Serialized)
        {
            If (ECAV ())
            {
                Switch (Arg0)
                {
                    Case (Zero)
                    {
                        Local0 = B1B2 (TH00,TH01) // TAH0 /* \_SB_.PCI0.LPCB.EC0_.TAH0 */
                        Break
                    }
                    Case (One)
                    {
                        Local0 = B1B2 (TH10,TH11) // TAH1 /* \_SB_.PCI0.LPCB.EC0_.TAH1 */
                        Break
                    }
                    Default
                    {
                        Return (Ones)
                    }

                }

                Local0 *= 0x02
                If ((Local0 != Zero))
                {
                    Divide (0x0041CDB4, Local0, Local1, Local0)
                    Return (Local0)
                }
                Else
                {
                    Return (Ones)
                }
            }
            Else
            {
                Return (Ones)
            }
        }
        
        Method (SMBR, 3, Serialized)
        {
            Local0 = Package (0x03)
                {
                    0x07, 
                    Zero, 
                    Zero
                }
            If (!ECAV ())
            {
                Return (Local0)
            }

            If ((Arg0 != RDBL))
            {
                If ((Arg0 != RDWD))
                {
                    If ((Arg0 != RDBT))
                    {
                        If ((Arg0 != RCBT))
                        {
                            If ((Arg0 != RDQK))
                            {
                                Return (Local0)
                            }
                        }
                    }
                }
            }

            Acquire (MUEC, 0xFFFF)
            Local1 = PRTC /* \_SB_.PCI0.LPCB.EC0_.PRTC */
            Local2 = Zero
            While ((Local1 != Zero))
            {
                Stall (0x0A)
                Local2++
                If ((Local2 > 0x03E8))
                {
                    Local0 [Zero] = SBBY /* \_SB_.PCI0.LPCB.EC0_.SBBY */
                    Local1 = Zero
                }
                Else
                {
                    Local1 = PRTC /* \_SB_.PCI0.LPCB.EC0_.PRTC */
                }
            }

            If ((Local2 <= 0x03E8))
            {
                Local3 = (Arg1 << One)
                Local3 |= One
                ADDR = Local3
                If ((Arg0 != RDQK))
                {
                    If ((Arg0 != RCBT))
                    {
                        CMDB = Arg2
                    }
                }

                WRBA (Zero) // BDAT = Zero
                PRTC = Arg0
                Local0 [Zero] = SWTC (Arg0)
                If ((DerefOf (Local0 [Zero]) == Zero))
                {
                    If ((Arg0 == RDBL))
                    {
                        Local0 [One] = BCNT /* \_SB_.PCI0.LPCB.EC0_.BCNT */
                        Local0 [0x02] = RDBA() // BDAT /* \_SB_.PCI0.LPCB.EC0_.BDAT */
                    }

                    If ((Arg0 == RDWD))
                    {
                        Local0 [One] = 0x02
                        Local0 [0x02] = B1B2 (T2B0,T2B1) // DT2B /* \_SB_.PCI0.LPCB.EC0_.DT2B */
                    }

                    If ((Arg0 == RDBT))
                    {
                        Local0 [One] = One
                        Local0 [0x02] = DAT0 /* \_SB_.PCI0.LPCB.EC0_.DAT0 */
                    }

                    If ((Arg0 == RCBT))
                    {
                        Local0 [One] = One
                        Local0 [0x02] = DAT0 /* \_SB_.PCI0.LPCB.EC0_.DAT0 */
                    }
                }
            }

            Release (MUEC)
            Return (Local0)
        }

        Method (SMBW, 5, Serialized)
        {
            Local0 = Package (0x01)
                {
                    0x07
                }
            If (!ECAV ())
            {
                Return (Local0)
            }

            If ((Arg0 != WRBL))
            {
                If ((Arg0 != WRWD))
                {
                    If ((Arg0 != WRBT))
                    {
                        If ((Arg0 != SDBT))
                        {
                            If ((Arg0 != WRQK))
                            {
                                Return (Local0)
                            }
                        }
                    }
                }
            }

            Acquire (MUEC, 0xFFFF)
            Local1 = PRTC /* \_SB_.PCI0.LPCB.EC0_.PRTC */
            Local2 = Zero
            While ((Local1 != Zero))
            {
                Stall (0x0A)
                Local2++
                If ((Local2 > 0x03E8))
                {
                    Local0 [Zero] = SBBY /* \_SB_.PCI0.LPCB.EC0_.SBBY */
                    Local1 = Zero
                }
                Else
                {
                    Local1 = PRTC /* \_SB_.PCI0.LPCB.EC0_.PRTC */
                }
            }

            If ((Local2 <= 0x03E8))
            {
                WRBA (Zero) // BDAT = Zero
                Local3 = (Arg1 << One)
                ADDR = Local3
                If ((Arg0 != WRQK))
                {
                    If ((Arg0 != SDBT))
                    {
                        CMDB = Arg2
                    }
                }

                If ((Arg0 == WRBL))
                {
                    BCNT = Arg3
                    WRBA (Arg4) // BDAT = Arg4
                }

                If ((Arg0 == WRWD))
                {
                //    DT2B = Arg4
                //    DTB0 = WECB (0x00, 16, Arg4)
                //    DTB1 = WECB (0x08, 16, Arg4)
                //    Store ( WECB (0x00, 16, Arg4), DTB0)
                //    Store ( WECB (0x08, 16, Arg4), DTB1)
                    Store (Arg4, T2B0)
                    Store (ShiftRight (Arg4, 8), T2B1)
                }

                If ((Arg0 == WRBT))
                {
                    DAT0 = Arg4
                }

                If ((Arg0 == SDBT))
                {
                    DAT0 = Arg4
                }

                PRTC = Arg0
                Local0 [Zero] = SWTC (Arg0)
            }

            Release (MUEC)
            Return (Local0)
        }
        
        Method (ECSB, 7, NotSerialized)
        {
            Local1 = Package (0x05)
                {
                    0x11, 
                    Zero, 
                    Zero, 
                    Zero, 
                    Buffer (0x20){}
                }
            If ((Arg0 > One))
            {
                Return (Local1)
            }

            If (ECAV ())
            {
                Acquire (MUEC, 0xFFFF)
                If ((Arg0 == Zero))
                {
                    Local0 = PRTC /* \_SB_.PCI0.LPCB.EC0_.PRTC */
                }
                Else
                {
                    Local0 = PRT2 /* \_SB_.PCI0.LPCB.EC0_.PRT2 */
                }

                Local2 = Zero
                While ((Local0 != Zero))
                {
                    Stall (0x0A)
                    Local2++
                    If ((Local2 > 0x03E8))
                    {
                        Local1 [Zero] = SBBY /* \_SB_.PCI0.LPCB.EC0_.SBBY */
                        Local0 = Zero
                    }
                    ElseIf ((Arg0 == Zero))
                    {
                        Local0 = PRTC /* \_SB_.PCI0.LPCB.EC0_.PRTC */
                    }
                    Else
                    {
                        Local0 = PRT2 /* \_SB_.PCI0.LPCB.EC0_.PRT2 */
                    }
                }

                If ((Local2 <= 0x03E8))
                {
                    If ((Arg0 == Zero))
                    {
                        ADDR = Arg2
                        CMDB = Arg3
                        If (((Arg1 == 0x0A) || (Arg1 == 0x0B)))
                        {
                            BCNT = DerefOf (Arg6 [Zero])
                            WRBA (DerefOf (Arg6 [One])) // BDAT = DerefOf (Arg6 [One])
                        }
                        Else
                        {
                            DAT0 = Arg4
                            DAT1 = Arg5
                        }

                        PRTC = Arg1
                    }
                    Else
                    {
                        ADD2 = Arg2
                        CMD2 = Arg3
                        If (((Arg1 == 0x0A) || (Arg1 == 0x0B)))
                        {
                            BCN2 = DerefOf (Arg6 [Zero])
                            WRBB (DerefOf (Arg6 [One])) // BDA2 = DerefOf (Arg6 [One])
                        }
                        Else
                        {
                            DA20 = Arg4
                            DA21 = Arg5
                        }

                        PRT2 = Arg1
                    }

                    Local0 = 0x7F
                    If ((Arg0 == Zero))
                    {
                        While (PRTC)
                        {
                            Sleep (One)
                            Local0--
                        }
                    }
                    Else
                    {
                        While (PRT2)
                        {
                            Sleep (One)
                            Local0--
                        }
                    }

                    If (Local0)
                    {
                        If ((Arg0 == Zero))
                        {
                            Local0 = SSTS /* \_SB_.PCI0.LPCB.EC0_.SSTS */
                            Local1 [One] = DAT0 /* \_SB_.PCI0.LPCB.EC0_.DAT0 */
                            Local1 [0x02] = DAT1 /* \_SB_.PCI0.LPCB.EC0_.DAT1 */
                            Local1 [0x03] = BCNT /* \_SB_.PCI0.LPCB.EC0_.BCNT */
                            Local1 [0x04] = RDBA() // BDAT /* \_SB_.PCI0.LPCB.EC0_.BDAT */
                        }
                        Else
                        {
                            Local0 = SST2 /* \_SB_.PCI0.LPCB.EC0_.SST2 */
                            Local1 [One] = DA20 /* \_SB_.PCI0.LPCB.EC0_.DA20 */
                            Local1 [0x02] = DA21 /* \_SB_.PCI0.LPCB.EC0_.DA21 */
                            Local1 [0x03] = BCN2 /* \_SB_.PCI0.LPCB.EC0_.BCN2 */
                            Local1 [0x04] = RDBB() // BDA2 /* \_SB_.PCI0.LPCB.EC0_.BDA2 */
                        }

                        Local0 &= 0x1F
                        If (Local0)
                        {
                            Local0 += 0x10
                        }

                        Local1 [Zero] = Local0
                    }
                    Else
                    {
                        Local1 [Zero] = 0x10
                    }
                }

                Release (MUEC)
            }

            Return (Local1)
        }

    }

    Scope (_SB.PCI0.LPCB)
    {
        Scope (EC0)
        {            
            Method (RDBA, 0, Serialized)
            {
                Name (TEMP, Buffer (0x20){})
                TEMP [Zero] = BA00 /* \_SB_.PCI0.LPCB.EC0_.BA00 */
                TEMP [One] = BA01 /* \_SB_.PCI0.LPCB.EC0_.BA01 */
                TEMP [0x02] = BA02 /* \_SB_.PCI0.LPCB.EC0_.BA02 */
                TEMP [0x03] = BA03 /* \_SB_.PCI0.LPCB.EC0_.BA03 */
                TEMP [0x04] = BA04 /* \_SB_.PCI0.LPCB.EC0_.BA04 */
                TEMP [0x05] = BA05 /* \_SB_.PCI0.LPCB.EC0_.BA05 */
                TEMP [0x06] = BA06 /* \_SB_.PCI0.LPCB.EC0_.BA06 */
                TEMP [0x07] = BA07 /* \_SB_.PCI0.LPCB.EC0_.BA07 */
                TEMP [0x08] = BA08 /* \_SB_.PCI0.LPCB.EC0_.BA08 */
                TEMP [0x09] = BA09 /* \_SB_.PCI0.LPCB.EC0_.BA09 */
                TEMP [0x0A] = BA0A /* \_SB_.PCI0.LPCB.EC0_.BA0A */
                TEMP [0x0B] = BA0B /* \_SB_.PCI0.LPCB.EC0_.BA0B */
                TEMP [0x0C] = BA0C /* \_SB_.PCI0.LPCB.EC0_.BA0C */
                TEMP [0x0D] = BA0D /* \_SB_.PCI0.LPCB.EC0_.BA0D */
                TEMP [0x0E] = BA0E /* \_SB_.PCI0.LPCB.EC0_.BA0E */
                TEMP [0x0F] = BA0F /* \_SB_.PCI0.LPCB.EC0_.BA0F */
                TEMP [0x10] = BA10 /* \_SB_.PCI0.LPCB.EC0_.BA10 */
                TEMP [0x11] = BA11 /* \_SB_.PCI0.LPCB.EC0_.BA11 */
                TEMP [0x12] = BA12 /* \_SB_.PCI0.LPCB.EC0_.BA12 */
                TEMP [0x13] = BA13 /* \_SB_.PCI0.LPCB.EC0_.BA13 */
                TEMP [0x14] = BA14 /* \_SB_.PCI0.LPCB.EC0_.BA14 */
                TEMP [0x15] = BA15 /* \_SB_.PCI0.LPCB.EC0_.BA15 */
                TEMP [0x16] = BA16 /* \_SB_.PCI0.LPCB.EC0_.BA16 */
                TEMP [0x17] = BA17 /* \_SB_.PCI0.LPCB.EC0_.BA17 */
                TEMP [0x18] = BA18 /* \_SB_.PCI0.LPCB.EC0_.BA18 */
                TEMP [0x19] = BA19 /* \_SB_.PCI0.LPCB.EC0_.BA19 */
                TEMP [0x1A] = BA1A /* \_SB_.PCI0.LPCB.EC0_.BA1A */
                TEMP [0x1B] = BA1B /* \_SB_.PCI0.LPCB.EC0_.BA1B */
                TEMP [0x1C] = BA1C /* \_SB_.PCI0.LPCB.EC0_.BA1C */
                TEMP [0x1D] = BA1D /* \_SB_.PCI0.LPCB.EC0_.BA1D */
                TEMP [0x1E] = BA1E /* \_SB_.PCI0.LPCB.EC0_.BA1E */
                TEMP [0x1F] = BA1F /* \_SB_.PCI0.LPCB.EC0_.BA1F */
                Return (TEMP) /* \_SB_.PCI0.LPCB.EC0_.RDBA.TEMP */
            }

            Method (WRBA, 1, Serialized)
            {
                Name (TEMP, Buffer (0x20){})
                TEMP = Arg0
                BA00 = DerefOf (TEMP [Zero])
                BA01 = DerefOf (TEMP [One])
                BA02 = DerefOf (TEMP [0x02])
                BA03 = DerefOf (TEMP [0x03])
                BA04 = DerefOf (TEMP [0x04])
                BA05 = DerefOf (TEMP [0x05])
                BA06 = DerefOf (TEMP [0x06])
                BA07 = DerefOf (TEMP [0x07])
                BA08 = DerefOf (TEMP [0x08])
                BA09 = DerefOf (TEMP [0x09])
                BA0A = DerefOf (TEMP [0x0A])
                BA0B = DerefOf (TEMP [0x0B])
                BA0C = DerefOf (TEMP [0x0C])
                BA0D = DerefOf (TEMP [0x0D])
                BA0E = DerefOf (TEMP [0x0E])
                BA0F = DerefOf (TEMP [0x0F])
                BA10 = DerefOf (TEMP [0x10])
                BA11 = DerefOf (TEMP [0x11])
                BA12 = DerefOf (TEMP [0x12])
                BA13 = DerefOf (TEMP [0x13])
                BA14 = DerefOf (TEMP [0x14])
                BA15 = DerefOf (TEMP [0x15])
                BA16 = DerefOf (TEMP [0x16])
                BA17 = DerefOf (TEMP [0x17])
                BA18 = DerefOf (TEMP [0x18])
                BA19 = DerefOf (TEMP [0x19])
                BA1A = DerefOf (TEMP [0x1A])
                BA1B = DerefOf (TEMP [0x1B])
                BA1C = DerefOf (TEMP [0x1C])
                BA1D = DerefOf (TEMP [0x1D])
                BA1E = DerefOf (TEMP [0x1E])
                BA1F = DerefOf (TEMP [0x1F])
            }

            Method (RDBB, 0, Serialized)
            {
                Name (TEMP, Buffer (0x20){})
                TEMP [Zero] = BB00 /* \_SB_.PCI0.LPCB.EC0_.BB00 */
                TEMP [One] = BB01 /* \_SB_.PCI0.LPCB.EC0_.BB01 */
                TEMP [0x02] = BB02 /* \_SB_.PCI0.LPCB.EC0_.BB02 */
                TEMP [0x03] = BB03 /* \_SB_.PCI0.LPCB.EC0_.BB03 */
                TEMP [0x04] = BB04 /* \_SB_.PCI0.LPCB.EC0_.BB04 */
                TEMP [0x05] = BB05 /* \_SB_.PCI0.LPCB.EC0_.BB05 */
                TEMP [0x06] = BB06 /* \_SB_.PCI0.LPCB.EC0_.BB06 */
                TEMP [0x07] = BB07 /* \_SB_.PCI0.LPCB.EC0_.BB07 */
                TEMP [0x08] = BB08 /* \_SB_.PCI0.LPCB.EC0_.BB08 */
                TEMP [0x09] = BB09 /* \_SB_.PCI0.LPCB.EC0_.BB09 */
                TEMP [0x0A] = BB0A /* \_SB_.PCI0.LPCB.EC0_.BB0A */
                TEMP [0x0B] = BB0B /* \_SB_.PCI0.LPCB.EC0_.BB0B */
                TEMP [0x0C] = BB0C /* \_SB_.PCI0.LPCB.EC0_.BB0C */
                TEMP [0x0D] = BB0D /* \_SB_.PCI0.LPCB.EC0_.BB0D */
                TEMP [0x0E] = BB0E /* \_SB_.PCI0.LPCB.EC0_.BB0E */
                TEMP [0x0F] = BB0F /* \_SB_.PCI0.LPCB.EC0_.BB0F */
                TEMP [0x10] = BB10 /* \_SB_.PCI0.LPCB.EC0_.BB10 */
                TEMP [0x11] = BB11 /* \_SB_.PCI0.LPCB.EC0_.BB11 */
                TEMP [0x12] = BB12 /* \_SB_.PCI0.LPCB.EC0_.BB12 */
                TEMP [0x13] = BB13 /* \_SB_.PCI0.LPCB.EC0_.BB13 */
                TEMP [0x14] = BB14 /* \_SB_.PCI0.LPCB.EC0_.BB14 */
                TEMP [0x15] = BB15 /* \_SB_.PCI0.LPCB.EC0_.BB15 */
                TEMP [0x16] = BB16 /* \_SB_.PCI0.LPCB.EC0_.BB16 */
                TEMP [0x17] = BB17 /* \_SB_.PCI0.LPCB.EC0_.BB17 */
                TEMP [0x18] = BB18 /* \_SB_.PCI0.LPCB.EC0_.BB18 */
                TEMP [0x19] = BB19 /* \_SB_.PCI0.LPCB.EC0_.BB19 */
                TEMP [0x1A] = BB1A /* \_SB_.PCI0.LPCB.EC0_.BB1A */
                TEMP [0x1B] = BB1B /* \_SB_.PCI0.LPCB.EC0_.BB1B */
                TEMP [0x1C] = BB1C /* \_SB_.PCI0.LPCB.EC0_.BB1C */
                TEMP [0x1D] = BB1D /* \_SB_.PCI0.LPCB.EC0_.BB1D */
                TEMP [0x1E] = BB1E /* \_SB_.PCI0.LPCB.EC0_.BB1E */
                TEMP [0x1F] = BB1F /* \_SB_.PCI0.LPCB.EC0_.BB1F */
                Return (TEMP) /* \_SB_.PCI0.LPCB.EC0_.RDBB.TEMP */
            }

            Method (WRBB, 1, Serialized)
            {
                Name (TEMP, Buffer (0x20){})
                TEMP = Arg0
                BB00 = DerefOf (TEMP [Zero])
                BB01 = DerefOf (TEMP [One])
                BB02 = DerefOf (TEMP [0x02])
                BB03 = DerefOf (TEMP [0x03])
                BB04 = DerefOf (TEMP [0x04])
                BB05 = DerefOf (TEMP [0x05])
                BB06 = DerefOf (TEMP [0x06])
                BB07 = DerefOf (TEMP [0x07])
                BB08 = DerefOf (TEMP [0x08])
                BB09 = DerefOf (TEMP [0x09])
                BB0A = DerefOf (TEMP [0x0A])
                BB0B = DerefOf (TEMP [0x0B])
                BB0C = DerefOf (TEMP [0x0C])
                BB0D = DerefOf (TEMP [0x0D])
                BB0E = DerefOf (TEMP [0x0E])
                BB0F = DerefOf (TEMP [0x0F])
                BB10 = DerefOf (TEMP [0x10])
                BB11 = DerefOf (TEMP [0x11])
                BB12 = DerefOf (TEMP [0x12])
                BB13 = DerefOf (TEMP [0x13])
                BB14 = DerefOf (TEMP [0x14])
                BB15 = DerefOf (TEMP [0x15])
                BB16 = DerefOf (TEMP [0x16])
                BB17 = DerefOf (TEMP [0x17])
                BB18 = DerefOf (TEMP [0x18])
                BB19 = DerefOf (TEMP [0x19])
                BB1A = DerefOf (TEMP [0x1A])
                BB1B = DerefOf (TEMP [0x1B])
                BB1C = DerefOf (TEMP [0x1C])
                BB1D = DerefOf (TEMP [0x1D])
                BB1E = DerefOf (TEMP [0x1E])
                BB1F = DerefOf (TEMP [0x1F])
            }
        }
    }

    Scope (_SB.PCI0)
    {
        Device (BAT0)
        {
            Method (_BIX, 0, NotSerialized)  // _BIX: Battery Information Extended
            {
                If (!^^LPCB.EC0.BATP (Zero))
                {
                    Return (NBIX) /* \_SB_.PCI0.BAT0.NBIX */
                }

                If ((^^LPCB.EC0.GBTT (Zero) == 0xFF))
                {
                    Return (NBIX) /* \_SB_.PCI0.BAT0.NBIX */
                }

                _BIF ()
                BIXT [One] = DerefOf (PBIF [Zero])
                BIXT [0x02] = DerefOf (PBIF [One])
                BIXT [0x03] = DerefOf (PBIF [0x02])
                BIXT [0x04] = DerefOf (PBIF [0x03])
                BIXT [0x05] = DerefOf (PBIF [0x04])
                BIXT [0x06] = DerefOf (PBIF [0x05])
                BIXT [0x07] = DerefOf (PBIF [0x06])
                BIXT [0x0E] = DerefOf (PBIF [0x07])
                BIXT [0x0F] = DerefOf (PBIF [0x08])
                BIXT [0x10] = DerefOf (PBIF [0x09])
                BIXT [0x11] = DerefOf (PBIF [0x0A])
                BIXT [0x12] = DerefOf (PBIF [0x0B])
                BIXT [0x13] = DerefOf (PBIF [0x0C])
                If ((DerefOf (BIXT [One]) == One))
                {
                    BIXT [One] = Zero
                    Local0 = DerefOf (BIXT [0x05])
                    BIXT [0x02] = (DerefOf (BIXT [0x02]) * Local0)
                    BIXT [0x03] = (DerefOf (BIXT [0x03]) * Local0)
                    BIXT [0x06] = (DerefOf (BIXT [0x06]) * Local0)
                    BIXT [0x07] = (DerefOf (BIXT [0x07]) * Local0)
                    BIXT [0x0E] = (DerefOf (BIXT [0x0E]) * Local0)
                    BIXT [0x0F] = (DerefOf (BIXT [0x0F]) * Local0)
                    Divide (DerefOf (BIXT [0x02]), 0x03E8, Local0, BIXT [0x02])
                    Divide (DerefOf (BIXT [0x03]), 0x03E8, Local0, BIXT [0x03])
                    Divide (DerefOf (BIXT [0x06]), 0x03E8, Local0, BIXT [0x06])
                    Divide (DerefOf (BIXT [0x07]), 0x03E8, Local0, BIXT [0x07])
                    Divide (DerefOf (BIXT [0x0E]), 0x03E8, Local0, BIXT [0x0E])
                    Divide (DerefOf (BIXT [0x0F]), 0x03E8, Local0, BIXT [0x0F])
                }

                BIXT [0x08] = B1B2 (^^LPCB.EC0.XC30,^^LPCB.EC0.XC31) // ^^LPCB.EC0.B0C3 /* \_SB_.PCI0.LPCB.EC0_.B0C3 */
                BIXT [0x09] = 0x0001869F
                Return (BIXT) /* \_SB_.PCI0.BAT0.BIXT */
            }
        }
    }
}

